// MNewPlayerCtl.cpp : Implementation of the CMNewPlayerCtrl ActiveX Control class.

#include "stdafx.h"
#include "MNewPlayer.h"
#include "MNewPlayerCtl.h"
#include "MNewPlayerPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void ThreadRefresh(void *param);

IMPLEMENT_DYNCREATE(CMNewPlayerCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CMNewPlayerCtrl, COleControl)
	//{{AFX_MSG_MAP(CMNewPlayerCtrl)
	ON_WM_SIZE()
	ON_WM_ACTIVATE()
	ON_WM_SETFOCUS()
	ON_WM_SYSCOMMAND()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CMNewPlayerCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CMNewPlayerCtrl)
	DISP_FUNCTION(CMNewPlayerCtrl, "StartMovie", StartMovie, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CMNewPlayerCtrl, "StopMovie", StopMovie, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CMNewPlayerCtrl, "UnloadProgram", UnloadProgram, VT_EMPTY, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CMNewPlayerCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CMNewPlayerCtrl, COleControl)
	//{{AFX_EVENT_MAP(CMNewPlayerCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CMNewPlayerCtrl, 2)
	PROPPAGEID(CMNewPlayerPropPage::guid)
	PROPPAGEID(CLSID_CPicturePropPage)
END_PROPPAGEIDS(CMNewPlayerCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CMNewPlayerCtrl, "MNEWPLAYER.MNewPlayerCtrl.1",
	0x62a13d16, 0x1a44, 0x418b, 0x96, 0x9a, 0x51, 0x98, 0x10, 0x2a, 0xa1, 0x59)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CMNewPlayerCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DMNewPlayer =
		{ 0x68e42cd8, 0x196d, 0x446e, { 0xa8, 0xc4, 0x86, 0x13, 0xb0, 0x23, 0x5, 0xa } };
const IID BASED_CODE IID_DMNewPlayerEvents =
		{ 0xcd660724, 0xc2a, 0x41f3, { 0xad, 0x70, 0x1a, 0xcb, 0xc2, 0x2c, 0x9f, 0xc5 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwMNewPlayerOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CMNewPlayerCtrl, IDS_MNEWPLAYER, _dwMNewPlayerOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::CMNewPlayerCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CMNewPlayerCtrl

BOOL CMNewPlayerCtrl::CMNewPlayerCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_MNEWPLAYER,
			IDB_MNEWPLAYER,
			afxRegApartmentThreading,
			_dwMNewPlayerOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::CMNewPlayerCtrl - Constructor

CMNewPlayerCtrl::CMNewPlayerCtrl()
{
	InitializeIIDs(&IID_DMNewPlayer, &IID_DMNewPlayerEvents);
	FlagDraw = -0;
	FirstTime = 1;
	m_bProgressMovement = FALSE;
	//CFastPlayerDoc *pDoc = new CFastPlayerDoc;
	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::~CMNewPlayerCtrl - Destructor

CMNewPlayerCtrl::~CMNewPlayerCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::OnDraw - Drawing function
void CMNewPlayerCtrl::CreateMyWindows(){
	//hVideo= CreateWindow ("STATIC", "",WS_CHILD | WS_VISIBLE | SS_BLACKFRAME,
	if(FirstTime == 1){
		InitCommonControls();
		FirstTime = 0;
	
	
		hVideo= CreateWindow ("STATIC", "",WS_CHILD | WS_VISIBLE | SS_BLACKFRAME,
                                            (MyRC.right - MyRC.left - X_BUTTON)/2 ,
											(MyRC.bottom - MyRC.top - Y_BUTTON)/2, 
											X_BUTTON, Y_BUTTON, m_hWnd, NULL,
                                            NULL, NULL);

		hPlay= CreateWindow ("BUTTON", "Play",WS_CHILD | WS_VISIBLE,0 ,0,DIMX_PLAY, DIMY_PLAY, m_hWnd, (HMENU)MYBUTTON1,NULL, NULL);
		hPause= CreateWindow ("BUTTON", "Pause",WS_CHILD | WS_VISIBLE,0 ,0,DIMX_PLAY, DIMY_PLAY, m_hWnd, (HMENU)MYBUTTON2,NULL, NULL);
		hStop= CreateWindow ("BUTTON", "Stop",WS_CHILD | WS_VISIBLE,0 ,0,DIMX_PLAY, DIMY_PLAY, m_hWnd, (HMENU)MYBUTTON3,NULL, NULL);
		hText= CreateWindow ("STATIC", "",WS_CHILD | WS_VISIBLE | SS_CENTER ,0 ,0,DIMX_PLAY, DIMY_PLAY, m_hWnd, (HMENU)MYBUTTON3,NULL, NULL);

		hScroll= CreateWindow ("msctls_trackbar32", "",WS_CHILD | WS_VISIBLE | TBS_BOTH | TBS_NOTICKS,10, 150, 290, 40, m_hWnd, (HMENU)MYTRACK,NULL, NULL);
		//m_progress.CreateWindow();
		

		::SetWindowPos(hPlay,NULL,(MyRC.right -MyRC.left - 3*DIMX_PLAY) / 2,MyRC.bottom - 3*DIMY_PLAY + 2, DIMX_PLAY, DIMY_PLAY , SWP_SHOWWINDOW);
		::SetWindowPos(hPause,NULL,(MyRC.right -MyRC.left - DIMX_PLAY) / 2,MyRC.bottom - 3*DIMY_PLAY +2, DIMX_PLAY, DIMY_PLAY , SWP_SHOWWINDOW);
		::SetWindowPos(hStop,NULL,(MyRC.right -MyRC.left + DIMX_PLAY) / 2,MyRC.bottom - 3*DIMY_PLAY +2, DIMX_PLAY, DIMY_PLAY , SWP_SHOWWINDOW);
		::SetWindowPos(hText,NULL,(MyRC.right -MyRC.left - DIMX_TEXT) / 2,MyRC.bottom - 2*DIMY_PLAY + 4, DIMX_TEXT, DIMY_TEXT , SWP_SHOWWINDOW);
		::SetWindowPos(hScroll,NULL,(MyRC.right -MyRC.left) / 2 - 100,MyRC.bottom - DIMY_TRACK - 2, 200, DIMY_TRACK , SWP_SHOWWINDOW);
		//m_progress.MoveWindow((rcBounds.right -rcBounds.left - DIMX_TEXT) / 2,rcBounds.bottom - 2*DIMY_PLAY + 4, DIMX_TEXT, DIMY_TEXT);
		
		::EnableWindow(hPlay, FALSE);
		::EnableWindow(hPause, FALSE);
		::EnableWindow(hStop, FALSE);

		
		::ShowWindow (hVideo, SW_SHOW);
		::BringWindowToTop(hVideo);
	}
}

//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	
	
	MyRC = rcBounds;

	
	// TODO: Replace the following code with your own drawing code.
	switch(FlagDraw){
	case 0:
		pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(BLACK_BRUSH)));
		//pdc->SetTextColor(RGB(100,100,100));
		//pdc->TextOut(0,(rcInvalid.bottom - rcInvalid.top) /2,"Movie player");
		break;
	case 1:
		break;
	case 2:
		// If no video is playing, fill the frame in black
		//if ((pDoc.m_currentStatus == CFastPlayerDoc::statusEmpty) || (pDoc.m_currentStatus == CFastPlayerDoc::statusStopped)){
			// Get the frame size
			
			//GetDlgItem(IDC_FRAME)->GetWindowRect(&rcFrame);
			//::ScreenToClient(&rcBounds);

			CBrush brBlack(RGB(0,0,0));
			pdc->FillRect(&rcBounds, &brBlack);
			
		//}
		break;

	}
	//::ShowWindow (hVideo, SW_SHOW);
	
	

}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::DoPropExchange - Persistence support
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	PX_Picture(pPX, "ControlPicture",m_pic);
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::OnResetState - Reset control to default state
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
	m_pic.CreateEmpty();

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl::AboutBox - Display an "About" box to the user
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_MNEWPLAYER);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CMNewPlayerCtrl message handlers
//------------------------------------------------------------------------------------
BOOL CMNewPlayerCtrl::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class

	cs.lpszClass = _T("Static");
	
	
	return COleControl::PreCreateWindow(cs);
}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::OnSize(UINT nType, int cx, int cy) 
{
	m_cxClient = cx;
	m_cyClient = cy;
	
	COleControl::OnSize(nType, cx, cy);
	

	
}

//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::ResizePlayWindow(){
	RECT grc, grcClient;
	HRESULT hr;
	long lVIDEOWidth, lVIDEOHeight;
	float scaleF;
	long Fdx, Fdy;
	float scaleFX, scaleFY;

	::GetClientRect(m_hWnd, &grc);
	::GetClientRect(hVideo, &grcClient);

	hr = pDoc.m_pBasicVideo->GetVideoSize(&lVIDEOWidth, &lVIDEOHeight);
	
	v_size_x = lVIDEOWidth; //save original video size
	v_size_y = lVIDEOHeight;
	
	Fdx = grc.right -grc.left;
	Fdy = grc.bottom - grc.top - 3 * DIMY_PLAY;

	if( (v_size_x >= Fdx) && (v_size_y >= Fdy) ){
		new_v_size_y = Fdy;
		new_v_size_x = Fdx;
		scaleFY = (float)new_v_size_y / v_size_y;
		scaleFX = (float)new_v_size_x / v_size_x;
		
		if(scaleFX >= scaleFY){
			new_v_size_x = (long)v_size_x * scaleFY;
			grcClient.left = (grc.right - new_v_size_x) / 2;
			grcClient.top = 0;
		}else{
			new_v_size_y = (long)v_size_y * scaleFX;
			grcClient.top = (grc.bottom - new_v_size_y) / 2;
			grcClient.left = 0 ;
			
		}
	}else{
		new_v_size_y = Fdy;
		new_v_size_x = Fdx;
		scaleFY = (float)new_v_size_y / v_size_y;
		scaleFX = (float)new_v_size_x / v_size_x;
		
		if(scaleFX >= scaleFY){
			new_v_size_x = (long)v_size_x * scaleFY;
			grcClient.left = (grc.right - new_v_size_x) / 2;
			grcClient.top = 0;
		}else{
			new_v_size_y = (long)v_size_y * scaleFX;
			grcClient.top = (grc.bottom - new_v_size_y) / 2;
			grcClient.left = 0 ;
			
		}

	}

	
	//MoveWindow(left, top, grc.right - grc.left, grc.bottom - grc.top, TRUE);
	::SetWindowPos(hVideo,NULL,grcClient.left, grcClient.top, new_v_size_x, new_v_size_y , SWP_SHOWWINDOW);

	
	
	//pDoc.m_pVideoWindow->SetWindowPosition(grcClient.left, grcClient.top - ClientTop, new_v_size_x, new_v_size_y );
	pDoc.m_pVideoWindow->SetWindowPosition(0, 0, new_v_size_x, new_v_size_y );

	::SetWindowPos(hScroll,NULL,(grc.right -grc.left - new_v_size_x) / 2,grc.bottom - DIMY_TRACK - 2, new_v_size_x, DIMY_TRACK , SWP_SHOWWINDOW);
	
	Sleep(10);

}
//------------------------------------------------------------------------------------
void ThreadRefresh(void *param){

	char TempText[255];
	UINT PlayPos = 0;

	CMNewPlayerCtrl *pThis = (CMNewPlayerCtrl* )param;
	while(1){
		Sleep(1000);
		if(pThis->pDoc.IsFilmOver()==1){
			sprintf(TempText,"\0");
			::SetWindowText(pThis->hText,TempText);
			
			pThis->Stop();
			return;
		}
		PlayPos = pThis->pDoc.GetPlaybackPosition();
		
		if(!(pThis->m_bProgressMovement))
			::SendMessage(  pThis->hScroll,(UINT) TBM_SETPOS,(WPARAM) TRUE,  (LPARAM) PlayPos);

		sprintf(TempText,"%s / %s",pThis->pDoc.GetPosiFilm(),pThis->pDoc.GetLenFilm());
		::SetWindowText(pThis->hText,TempText);
		
	}

}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::DoDataExchange(CDataExchange* pDX) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	COleControl::DoDataExchange(pDX);
}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::StartMovie(LPCTSTR MovieName){
		FlagDraw = 2;
	
	HRESULT hr;
	DWORD dThId, exCode = 0;

	strcpy(ExtMovieName, MovieName);
	pDoc.OpenDocument (MovieName );
	if (pDoc.m_currentStatus != CFastPlayerDoc::statusEmpty){
		CreateMyWindows();

		hr = pDoc.m_pVideoWindow->put_Owner((OAHWND)hVideo);
		

		hr = pDoc.m_pVideoWindow->put_MessageDrain((OAHWND)hVideo);

		BOOL bAudio = (pDoc.m_pBasicAudio != NULL);	
		ResizePlayWindow();
		pDoc.Play ();
		TerminateThread(MyHThread,exCode);
		//m_Progress.SetRange(0, 1000);
		
		::SendMessage(  hScroll,(UINT) TBM_SETRANGEMAX,(WPARAM) TRUE,  (LPARAM) 1000);  
		m_bProgressMovement = FALSE;

		MyHThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ThreadRefresh, (void *)this, 0, &dThId);
		
		::EnableWindow(hPlay, FALSE);
		::EnableWindow(hPause, TRUE);
		::EnableWindow(hStop, TRUE);

	}

	SetModifiedFlag();

}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::Stop(){

	::EnableWindow(hPlay, TRUE);
	::EnableWindow(hPause, FALSE);
	::EnableWindow(hStop, FALSE);
	pDoc.Stop ();
	//m_Progress.SetPos(0);
	::SendMessage(  hScroll,(UINT) TBM_SETPOS,(WPARAM) TRUE,  (LPARAM) 0);

}
//------------------------------------------------------------------------------------

BOOL CMNewPlayerCtrl::OnCommand(WPARAM wParam, LPARAM lParam){
	
	UINT nId = LOWORD(wParam);

	HWND hWndCtrl = (HWND)LOWORD(lParam);    //Control handle
	int nCode = HIWORD(lParam);              //Notification code


			switch(nId){
			case MYBUTTON1:
				::EnableWindow(hPlay, FALSE);
				::EnableWindow(hPause, TRUE);
				::EnableWindow(hStop, TRUE);
				StartMovie(ExtMovieName);
				
				break;
			case MYBUTTON2:
				::EnableWindow(hPlay, FALSE);
				::EnableWindow(hPause, TRUE);
				::EnableWindow(hStop, TRUE);
				pDoc.Pause ();
				break;
			case MYBUTTON3:
				Stop();
				break;
			}


	
	
	return COleControl::OnCommand(wParam, lParam);
}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar->GetDlgCtrlID() == MYTRACK){
		if (nSBCode == TB_THUMBTRACK)
		{
			//Beep(50,200);
			// Disable progress update
			m_bProgressMovement = TRUE;
			return;
		}
		else if (nSBCode == TB_ENDTRACK)
		{
			// Signal the document to change position
			pDoc.ChangePlaybackPosition(::SendMessage(hScroll,(UINT) TBM_GETPOS,(WPARAM) 0,(LPARAM) 0) );
			m_bProgressMovement = FALSE;
		}
	}
	
	COleControl::OnHScroll(nSBCode, nPos, pScrollBar);
}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::StopMovie(){
	
	DWORD exCode = 0;
	TerminateThread(MyHThread,exCode);
	Stop();

}
//------------------------------------------------------------------------------------
void CMNewPlayerCtrl::UnloadProgram(){
	DWORD exCode = 0;

	TerminateThread(MyHThread,exCode);
	pDoc.Close();

}
//------------------------------------------------------------------------------------